/*********************************************************************
 *
 *       *** HAPPy Pascal Compiler ***
 *             program,block RpC
 *
 *                void programme(void)
 *                void block(Set fsys,enum symbol fsy,ctp *fprocp)
 *
 *       Copyright (c) H.Asano 1992.
 *
 *********************************************************************/
 
#define  EXTERN extern
#include <stdlib.h>
#include <string.h>
#include "pascomp.h"
#include "pcpcd.h"

void block(Set,enum symbol,ctp*) ;
static void body(Set,ctp*)  ;
static void paramcopy(ctp*) ;
static void statement(Set)  ;
static void compoundstatement(Set)    ;
static void ifstatement(Set)     ;
static void whilestatement(Set)  ;
static void repeatstatement(Set) ;
static void forstatement(Set)    ;
static void forident(attr*)      ;
static void forexpres1(Set,attr); 
static void forexpres2(Set,attr,enum symbol,int*,int*) ;
static void fordostatement(Set,attr,enum symbol,int) ;
static void assignment(Set,ctp*) ;
static void casestatement(Set) ;
static void withstatement(Set) ;
static void gotostatement(Set) ;
extern void call(Set,ctp*) ;
extern void expression(Set) ;
extern void selector(Set,ctp*) ;
extern ctp  *mkctp(char*,enum idclass,stp*,ctp*) ;
extern void enterid(ctp*) ;
extern ctp  *searchid(Set);
extern ctp  *searchsection(ctp*) ;
extern void insymbol(void);
extern void skip(Set) ;
extern void updatelc(int)    ;
extern void pcerr(int,char*) ;
extern char *inttoch(long)   ;
extern char *inttoch(long)   ;
extern char *inttoch(long) ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *orset(Set*,Set*)    ;
extern Set  *dfset(Set*,Set*) ;
extern int  crelabel(void) ;
extern void labeldecl(Set);
extern void constdecl(Set);
extern void typedecl(Set);
extern void vardecl(Set,ctp*);
extern void procfuncdecl(Set,enum symbol,ctp**);
extern void gencupent(enum pcdmnc, int, int) ;
extern void genjump(enum pcdmnc,int) ;
extern void putlabel(int) ;
extern void genret(stp*) ;
extern void putprogname(char*);
extern void putlblv(int,int) ;
extern void putq(void) ;
extern void gen0(enum pcdmnc) ;
extern void gen1(enum pcdmnc, int) ;
extern void gen0t(enum pcdmnc,stp*) ;
extern void gen1t(enum pcdmnc,stp*,int) ;
extern void gen2t(enum pcdmnc,stp*,int,int) ;
extern void genlca(void) ;
extern void genlda(int,int) ;
extern void genldc(char,long) ;
extern void genchk(stp*,int,long,long) ;
extern void convertint(stp*) ;
extern void load(void) ;
extern void loadaddress(void) ;
extern void store(attr) ;
extern void gencompare(enum pcdmnc,char,int) ;
extern void checkbounds(stp*,int) ;
extern boolean compatible(stp*,stp*) ;
extern boolean assigncompati(stp*,stp*) ;
extern int  align(stp*,int) ;
extern void constant(Set,stp**,union valu*) ;
extern void *Malloc(int)  ;

static int lcmax    ;


/*******************************************************
 *   programme() : program     
 *     `́A2ʂ
 *        program ident( filename,filename, ) ;  
 *        program ident;
 *******************************************************/
void programme(void)
{
  extfilep  *extfp ;                    /* t@Ci[GÃ|C^   */
  Set       fsys   ;                    /* block  ŏɌsymbol̏W*/
  Set       casesys;                    /* casesy̏W ([N)        */
  ctp       *cp    ;                    /* input,outputOo^p           */
  int       i      ;
  int       adr    ;
  boolean   err196 ;

     fextfilep = nil ;

     if(sy == progsy) {
      insymbol();
      if(sy != ident) pcerr(2,"");      /* OȂ                 */
      putprogname(id) ;                 /* vȌo         */
      insymbol();
      if((sy != lparent) && (sy != semicolon))  
       pcerr(14,"");                    /* ; Ȃ                   */

      if(sy == lparent) {               /* vȌ       */
       do {
        insymbol();
        if(sy == ident) {
          err196 = false    ;
          extfp = fextfilep ;
          while(extfp) {                /* dw`FbN           */
           if(!strcmp(extfp->filename,id)) {
            pcerr(196,id) ;             /* vOɓO   */
            err196 = true ;
           } 
           extfp = extfp->nextfile ;
          }
          if(!err196) {
           if(!(i=strcmp(id,"input")) || !(strcmp(id,"output"))) {
            if(i!=0) {                  /* output̎                 */
             adr = outputadr ;
             defineoutput = true ;      /* outputt@C`       */
            }
            else {                      /* input̎                  */
             adr = inputadr ;
             defineinput = true ;       /* inputt@C`        */
            }
            cp = mkctp(id,vars,textptr,nil) ;
            cp->n.v.vkind = actual ;
            cp->n.v.vlev  = level  ;
            cp->n.v.vaddr = adr    ;
            enterid(cp);
           } 

           extfp = (extfilep*)Malloc(sizeof(extfilep)) ;
           strcpy(extfp->filename,id);
	   extfp->nextfile = fextfilep ;
           fextfilep = extfp ;
          }

          insymbol() ;
          if((sy != comma) && (sy != rparent))
           pcerr(20,"") ;               /* , Ȃ                   */
        }
	else pcerr(2,"") ;              /* OȂ                 */
       } while(sy == comma);
       if(sy != rparent) pcerr(14,"");  /* ; Ȃ                   */
       insymbol();
      }
      if(sy!=semicolon) pcerr(14,"");   /* ; Ȃ                   */
      else insymbol();
     }
     else pcerr(3,"") ;                 /* program Ȃ             */

     fsys = blockbegsys        ;        /* fsys =  blockbegsys        */
     orset(&fsys,&statbegsys)  ;        /*       + statbegsys         */
     mkset(&casesys,casesy,-1) ;
     dfset(&fsys,&casesys)     ;        /*       - casesy             */  

     do {                               /* 񕜂̂repeat       */
      block(fsys,period,nil) ;          /* block  RpC        */
      if(sy != period) pcerr(21,"") ;   /*  *Ȃ                   */
     } while(sy != period)   ; 

}

/**************************************/
/* block() : block  |            */
/**************************************/
void block(Set fsys,         /* blockɍŏɌsymbol̏W    */
           enum symbol fsy,  /* block̏Isymbol              */ 
           ctp *fprocp)      /* proc/func̖O|C^(mainnil) */
           
{
  enum symbol lsy ;
  Set bodyfsys    ;
  ctp *pffwdptr = nil  ;                /* 葱֐̑O錾Xg*/
  ctp *lcp        ;
  extfilep *extp  ;                     /* vOXg       */

     do {                               /* declare part̏         */
      if(sy == labelsy) {
       insymbol() ;
       labeldecl(fsys) ;                /* label߂̏              */
      }
      if(sy == constsy) {
       insymbol() ;
       constdecl(fsys) ;                /* const߂̏              */
      }
      if(sy == typesy)  {
       insymbol() ;
       typedecl(fsys)  ;                /* type߂̏               */
      }
      if(sy == varsy)   {
       insymbol() ;
       vardecl(fsys,fprocp)   ;         /* var߂̏                */
      } ;

      if(fprocp == nil) {               /* CubN̎         */
       extp = fextfilep ;
       while(extp) {                    /* vO̐錾`FbN*/
        strcpy(id,extp->filename) ;
        lcp = searchsection(display[level].fname) ;
        if(!lcp) pcerr(197,id) ;        /* vO錾      */
        extp = extp->nextfile  ;
       }
       
       gen1(iMST,0) ;                   /*  mst߂̐             */
       mainlabel = crelabel()       ;   /*  CubÑx  */
       gencupent(iCUP,0,mainlabel ) ;   /*  cup߂̐             */
       gen0(iSTP)   ;                   /*  stp߂̐             */

      }

      while((sy == procsy) || (sy == funcsy)) {
       lsy = sy   ;
       insymbol() ;
       procfuncdecl(fsys,lsy,&pffwdptr) ;/* 葱֐̐錾     */
      } ;
      
      while(pffwdptr) {                 /* 葱֐̑O錾`FbN*/
       pcerr(118,pffwdptr->name) ;      /*  O錾̎̂Ȃ      */
       pffwdptr = pffwdptr->n.pf.sd.d.af.a.fwdptr ;
      }
       
      if(sy != beginsy) {
       pcerr(18,"") ;                   /* 錾Ɍ肪         */
       skip(fsys) ;
      } ;
     
     } while(! inset(statbegsys,sy)) ;  /* 񕜂̂ߌJԂ     */
     
     if(sy == beginsy) insymbol()   ;
     else              pcerr(17,"") ;   /* begin Ȃ               */

     bodyfsys = fsys ;
     addset(bodyfsys,casesy) ;
     do {
      body(bodyfsys,fprocp)     ;       /* begin ` end ̏        */
      if(sy != fsy) {
       pcerr(6,"") ;                    /* sȋLꂽ         */
       skip(fsys)  ;
      }
     } while((sy != fsy) && (! inset(blockbegsys,sy))) ;
}

/**************************************/
/* body() : body  |            */
/**************************************/
static void body(Set fsys,ctp *fprocp)
{
  lbp *llp     ;
  int entname  ;
  Set statementfsys ;
  int stacktop ;
  int segsize ;
  boolean test ;

     topnew = topmax = lcaftermarkstack ;
     entname = (!fprocp) ? mainlabel               /* mainbody̎       */
                 : fprocp->n.pf.sd.d.af.a.pfname ; /* 葱֐̃xl*/

     putlabel(entname)    ;             /* x̏o               */
     segsize = crelabel() ;
     stacktop= crelabel() ;
     gencupent(iENT,1,segsize) ;
     gencupent(iENT,2,stacktop) ;


     if(fprocp) paramcopy(fprocp) ;     /* 葱֐̎ 
                                               X^bNɃRs[   */
     lcmax = lc ;

    /**** statement  @****/

     statementfsys = fsys ;             /* statementfsys =            */
     addset(statementfsys,semicolon);   /*  fsys + semicolon          */
     addset(statementfsys,endsy)    ;   /*       + endsy              */
     do {
      do {
       statement(statementfsys);
      } while(inset(statbegsys,sy)) ;
      if(test=(sy == semicolon)) insymbol() ;  /* ; ȂΎsymbolǂ */
     } while(test) ;                           /* ; ȂΌJԂ    */
     if(sy == endsy) insymbol() ;
     else pcerr(13,"") ;                /* end Ȃ                 */

   /**** x̒``FbN ****/

     llp = display[top].flabel;
     while(llp) {                       /* 錾ꂽxɂ   */
      if(!llp->defined)                 /*   `                   */
       pcerr(168,inttoch((long)llp->labval)); /* xo         */
      llp = llp->nextlab ;
     }

     if(fprocp) {                       /* 葱֐̃ubN̎*/
      genret(fprocp->idtype) ;          /* ^ɉretߐ      */
      if(fprocp->klass == func)         /* ֐̎                   */
       if(!display[top].funcassign)     /*   ֐ւ̑Ȃ   */
        pcerr(176,fprocp->name) ;       /*     ֐ւ̑Ȃ   */
     }   
     else genret(nil)        ;          /* mainubN̎retp */

     putlblv(segsize , lcmax ) ;               
     putlblv(stacktop, topmax) ;
     if(!fprocp) putq()  ;              /* mainubN̎ qw߂o*/
     
}

/**************************************/
/* paramcopy() : l̃Rs[   */
/**************************************/
static void paramcopy(ctp *fprocp)
{
  ctp *lcp ;
  int llc ;

     llc = lcaftermarkstack ;
     lcp = fprocp->next     ;           /* ̐擪                 */

     while(lcp) {
      llc = align(parmptr,llc) ;        /* E                   */
      if(lcp->klass == vars)            /* ϐ̎                   */
       if(lcp->idtype)
        if(lcp->idtype->form > power) { /* z񥃌R[h^            */
         if(lcp->n.v.vkind == actual) { /* l                     */
          genlda(0,lcp->n.v.vaddr) ;    /* lda                    */
          gen2t(iLOD,nilptr,0,llc) ;    /* lod                    */
          gen2t(iMOV,nil,1,lcp->idtype->size); /* mov             */
         }
         llc += ptrsize ;
        }
        else llc += lcp->idtype->size ; /* XJ͈ͤW|C^  */
      lcp = lcp->next ;
     }
}

/**************************************/
/* statement() :   RpC     */
/**************************************/
static void statement(Set fsys)
{
  Set ws ;
  Set statfolsys ;                      /* ̌ɑsymbol̏W   */
  Set identsys   ;                      /* ȌW                 */
  ctp *lcp ;
  lbp *llp ;

     mkset(&statfolsys, semicolon,endsy,elsesy,untilsy,-1);
     mkset(&identsys,   vars,field,func,proc,-1) ;

  /**** label   ****/
     if(sy == intconst) {
      llp = display[level].flabel ;
      while(llp) {
       if(llp->labval == (int)val.ival) {  /* 錾ꂽx̎    */
        if(llp->defined)
         pcerr(165,inttoch(val.ival));/* xēx錾ꂽ       */
        putlabel(llp->labname)     ;  /* xl̏o               */
        llp->defined = true        ;  /* `                       */
        break ;
       }
       else llp = llp->nextlab     ;    /* xႤ           */
      }
      if(!llp)
       pcerr(167,inttoch(val.ival));    /* x錾             */
      insymbol() ;
      if(sy == colon) insymbol()   ;
      else pcerr(5,"")             ;    /* : Ȃ@                 */
     }

  /***********************/

     if((! inset(fsys,sy)) && (sy != ident)) {    /* Ȃsymbol̎ */
      pcerr(6,"") ;                               /* ssymbolꂽ */
      skip(fsys)  ;
     }
     if((inset(fsys,sy)) || (sy == ident)) {      /* ̍ŏƂOK̎ */
      switch(sy) {
       case ident :    lcp=searchid(identsys) ;
                       insymbol() ;
                       if(lcp->klass != proc)
                        assignment(fsys,lcp) ;      /* ̏   */
                       else if((lcp->klass == proc) &&
                               (inset(statfolsys,sy) || (sy == lparent)))
                        call(fsys,lcp) ;            /* 葱̂݌ďo */
                       else {           
                        pcerr(6,"") ;   /* sȋLꂽ         */
                        ws = fsys ;
                        orset(&ws,&statfolsys) ;
                        skip(ws)  ;     /* ǂݔ΂                 */
                       }
                       break ; 
       case beginsy  : insymbol() ;
                       compoundstatement(fsys) ;
                       break ;
       case gotosy   : insymbol() ;
                       gotostatement(fsys) ;
                       break ;
       case ifsy     : insymbol() ;
                       ifstatement(fsys) ;
                       break ;
       case casesy   : insymbol() ;
                       casestatement(fsys) ;
                       break ;
       case whilesy  : insymbol() ;
                       whilestatement(fsys) ;
                       break ;
       case repeatsy : insymbol() ;
                       repeatstatement(fsys) ;
                       break ;
       case forsy    : insymbol() ;
                       forstatement(fsys) ;
                       break ;
       case withsy   : insymbol() ;
                       withstatement(fsys) ;
      }

      if(! inset(statfolsys,sy)) {
       pcerr(6,"") ;                    /* sȋLꂽ         */
       skip(fsys) ;
      }
     }
}

/***************************************/
/* compoundstatement() : begin̏ */
/***************************************/
static void compoundstatement(Set fsys)
{
  Set ws;
  boolean test;

     do {
      do {
       mkset(&ws,semicolon,endsy,-1);
       orset(&ws,&fsys) ;
       statement(ws) ;
      } while(inset(statbegsys,sy)) ; /* statementȊOłĂI*/
      if(test = (sy == semicolon)) insymbol() ; /* ; ȂΎsymbol */
     } while(test) ;                    /* ; ȂΌJԂ           */
     
     if(sy == endsy) insymbol() ;       /* end ȂΎsymbol       */
     else pcerr(13,"") ;                /*  end Ȃ                */
}

/***************************************/
/*   gotostatement() : gotȍ    */
/***************************************/
static void gotostatement(Set fsys)
{
  lbp *llp ;
  int ttop,ttop1 ;
  boolean found ;

     if(sy == intconst) {               /* x͐               */
      found = false ;
      ttop  = top   ;
      while(display[ttop].occur != blck) 
        ttop-- ;                        /* blockT            */
      ttop1 = ttop ;
      do {
       llp = display[ttop].flabel ;
       while(llp) {
        if(llp->labval == (int)val.ival) { /* xl          */
         found = true ;
         if(ttop == ttop1)              /* x̒`Ɠ     */
          genjump(iUJP,llp->labname) ;  /* ujp                    */
         else
          gencupent(iEJP,level-ttop,llp->labname); /* ejp         */
         break ;                        /* while[v𔲂        */
        }
        else llp = llp->nextlab ;
       }
       ttop-- ;
      } while((! found) && (ttop != 0)) ;
      if(! found)
       pcerr(167,inttoch(val.ival));    /* x錾             */
      insymbol() ;
     }
     else pcerr(164,"") ;               /* xłȂ         */
}

/***************************************/
/*    ifstatement() : if̏       */
/***************************************/
static void ifstatement(Set fsys)
{
  int lcix1,lcix2 ;
  Set ws ;

     ws = fsys ;
     addset(ws,thensy) ;
     expression(ws) ;                   /* if̎̎]           */
     load()               ;             /* ̒lload           */
     if(gattr.typtr)
      if(gattr.typtr != boolptr)        /* ̒lbooleanłȂ    */
       pcerr(146,"if")  ;             /*  ZΏۂ͘_^łȂƑʖ*/
     lcix1 = crelabel()   ;
     genjump(iFJP,lcix1)  ;             /* UȂelse܂if̏Iɔ*/

     if(sy == thensy) insymbol() ;
     else pcerr(52,"")    ;             /* then Ȃ                */

     ws = fsys ;
     addset(ws,elsesy)    ;
     statement(ws)        ;             /* then̎̕         */

     if(sy == elsesy) {
      lcix2 = crelabel()  ;
      genjump(iUJP,lcix2) ;             /* elsȅI܂Ŕ       */
      putlabel(lcix1)     ;             /* elsẽxo           */
      insymbol()          ;
      statement(fsys)     ;             /* else̎̕         */
      putlabel(lcix2)     ;             /* elsȅĨxo   */
     }
     else putlabel(lcix1) ;             /* elseȂ if̏Ĩx*/
}

/***************************************/
/*  whilestatement() : whilȅ   */
/***************************************/
static void whilestatement(Set fsys)
{
  int laddr ;                           /* ߂胉xl               */
  int lcix  ;                           /* щzxl           */
  Set ws    ;
  
     laddr = crelabel() ;               /* xl𓾂             */
     putlabel(laddr)    ;               /* xl̏o             */

     ws = fsys ;
     addset(ws,dosy)    ;
     expression(ws)     ;               /* while̎̎̕]        */
     load()             ;               /* ̒lload           */
     if(gattr.typtr) 
      if(gattr.typtr != boolptr)        /* ̒lbooleanłȂ    */
       pcerr(146,"while")  ;          /*  ZΏۂ͘_^łȂƑʖ*/
     lcix = crelabel()  ;               /* щzxl𓾂     */
     genjump(iFJP,lcix) ;               /* fjp߂̐              */
     if(sy == dosy) insymbol() ;
     else pcerr(54,"")  ;               /* do Ȃ                  */

     statement(fsys)    ;               /* ̏                   */

     genjump(iUJP,laddr);               /* ujp߂while̐擪ɖ߂*/

     putlabel(lcix)     ;               /* ѐ惉x̏o         */
}

/*****************************************/
/*  repeatstatement() : repeat̏   */
/*****************************************/
static void repeatstatement(Set fsys)
{
  int laddr ;                           /* ߂胉xl               */
  Set ws    ;
  boolean test ;

     laddr = crelabel() ;               /* xl𓾂             */
     putlabel(laddr)    ;               /* xl̏o             */

     mkset(&ws,semicolon,untilsy,-1);
     orset(&ws, &fsys) ;
     do {
      do {
       statement(ws)   ;                 /* ̏                   */
       if(inset(statbegsys,sy))
        pcerr(14,"") ;                   /*  ; Ȃ                  */
      } while(inset(statbegsys,sy)); /*  ƂĐsymbolȂ߰ */
      if(test = (sy==semicolon)) insymbol() ; /* ; ȂΎsymbol    */
     } while(test) ;                     /*      ; ȂΌJԂ      */
     
     if(sy == untilsy) {
      insymbol() ;
      expression(fsys) ;                /* untilɑ̕]        */
      load()             ;              /* ̒lload           */
      if(gattr.typtr)
       if(gattr.typtr != boolptr)       /* ̒lbooleanłȂ    */
        pcerr(146,"repeat") ;         /*  ͘_łȂ          */
      genjump(iFJP,laddr) ;             /* fjp߂̐              */
     }
     else pcerr(53,"") ;                /* until Ȃ               */
}

/***************************************/
/* forstatement() : for̃RpC  */
/***************************************/
static void forstatement(Set fsys)
{
  attr lattr ;
  int  llc   ;
  enum symbol lsy ;
  int  looplabel  ;                     /* for̃[vpxl    */
  int  forendlabel;                     /* forI̔ѐ惉xl  */
  Set  ws    ;

     llc = lc ;                         /* ϐ󋵂ޔ     */
     lattr.typtr  = nil   ;             /* ϐ̑ݒ     */
     lattr.kind   = varbl ;
     lattr.access = drct  ;
     lattr.vlevel = level ;
     lattr.dplmt  = 0     ;
     
     if(sy == ident) forident(&lattr) ;
     else {
      pcerr(2,"") ;                     /* OȂ                 */
      mkset(&ws,becomes,tosy,downtosy,dosy,-1) ;
      orset(&ws,&fsys) ;
      skip(ws)    ;                     /*     ǂݔ΂             */
     }

     if(sy == becomes) forexpres1(fsys,lattr) ;  /* 1̏         */
     else {
      pcerr(51,"") ;                    /* := Ȃ                  */
      mkset(&ws,tosy,downtosy,dosy,-1) ;
      orset(&ws,&fsys) ;
      skip(ws)     ;                    /*     ǂݔ΂             */
     }

     if((sy == tosy) || (sy == downtosy)) {
      lsy = sy     ;                    /* to  downsyŔf邽ߑޔ*/
      forexpres2(fsys,lattr,lsy,&looplabel,&forendlabel) ; /* 2̏      */
     } 
     else {
      pcerr(55,"") ;                    /* to / downto Ȃ         */
      mkset(&ws,dosy,-1) ;
      orset(&ws,&fsys)   ;
      skip(ws)           ;              /*     ǂݔ΂             */
     }
     
     if(sy == dosy) insymbol() ;
     else pcerr(54,"")   ;              /* do Ȃ                  */

     fordostatement(fsys,lattr,lsy,looplabel) ;    /* doɑ̏*/

     putlabel(forendlabel) ;            /* foȑI胉xo    */
     
     lc = llc              ;            /* ꎞϐJ             */
}

/***************************************/
/* forident() : for̐ϐ    */
/***************************************/
static void forident(attr *fattr)
{
  ctp *lcp ;
  Set ws   ;
  int ltop ;

     mkset(&ws,vars,-1) ;
     lcp = searchid(ws) ;               /* ϐ̒疼OT     */

     (*fattr).typtr = lcp->idtype ;     /*   ϐ̌^                 */
     (*fattr).kind  = varbl       ;
     if(lcp->n.v.vkind == actual) {     /* ϐȂOK             */
      (*fattr).access = drct ;
      (*fattr).vlevel = lcp->n.v.vlev ; /*    ϐ̐錾x        */
      (*fattr).dplmt  = lcp->n.v.vaddr; /*    ϐ̊AhX  */
      ltop = top ;
      while(display[ltop].occur != blck) /* blockT           */
       ltop-- ;
      if(lcp->n.v.vlev != ltop)         /* ϐ̒`       */
       pcerr(186,id) ;                  /*  forƓԂłȂ */ 
     }
     else {
      pcerr(187,id) ;                   /* ϐ𐧌ϐɎgȂ */
      (*fattr).typtr = nil ;
     }

     if((*fattr).typtr)
      if(((*fattr).typtr->form > subrange) ||     /* |C^^W^   */
                                                  /* R[h^t@C^*/
         (realptr == (*fattr).typtr)) {           /* ܂real^         */
       pcerr(188,id) ;                            /* ϐ̌^s   */
       (*fattr).typtr = nil ;
      }

     insymbol() ;
}

/***************************************/
/* forexpres1() : for̎1       */
/*      for ϐ:=1          */
/***************************************/
static void forexpres1(Set fsys,attr fattr)
{
  Set ws ;
   
     insymbol() ;

     mkset(&ws,tosy,downtosy,dosy,-1) ;
     orset(&ws,&fsys) ;
     expression(ws)   ;                 /* 1]                  */

     if(gattr.typtr)
      if((gattr.typtr->form != scalar) || (gattr.typtr == realptr))
       pcerr(144,"foȑl")  ;/* łȂ               */
      else if(compatible(fattr.typtr,gattr.typtr)) {   /* ϐƌ^*/
       load() ;                         /* ̒lload               */
       store(fattr) ;                   /* ϐstore          */
      }
      else pcerr(145,"l") ;        /* ϐƏľ^sK*/
}       

/****************************************/
/* forexpres2() : for̎2        */
/*   for  to/downto 2 do        */
/****************************************/
static void forexpres2(Set fsys,attr fattr,
                       enum symbol fsy,int *flooplabel,int *forendlabel)
{
  stp  *lspfin ;
  char typind  ;                        /* gencompareɈn^ */
  int  tempadr ;                        /* ꎞϐ̃AhX       */
  Set ws ;

     insymbol() ;

     ws = fsys ;
     addset(ws,dosy) ;
     expression(ws) ;                   /* 2]                  */

     lspfin = gattr.typtr ;             /* Il̑ޔ           */
     if(lspfin == boolptr)      typind = 'b' ;    /* boolean          */
     else if(lspfin == charptr) typind = 'c' ;    /* char             */
     else                       typind = 'i' ;    /* integer/񋓌^   */

     if(lspfin)
      if((lspfin->form != scalar) || (lspfin == realptr))
       pcerr(144,"foȑIl")  ;          /* łȂ           */
      else if(compatible(fattr.typtr,lspfin)) {  /* ϐƌ^*/
       load() ;                             /* ̒lload           */
       updatelc(align(lspfin,lc) - lc) ;    /* E킹             */
       tempadr = lc ;
       gen2t(iSTR,lspfin,0,tempadr) ;       /* ꎞϐɎ̒lstr*/
       *flooplabel = crelabel() ;
       if(!debug)                            /* debugłȂȂ      */
        putlabel(*flooplabel) ;              /* [vxo       */
       gattr = fattr  ;
       load()          ;                     /* ϐload         */
       gen2t(iLOD,lspfin,0,tempadr) ;        /* ꎞϐ(2)load    */
       updatelc(lspfin->size)       ;
       if(lc > lcmax) lcmax =lc ;            /* őϐTCY̍XV */
       (fsy == tosy) ? gencompare(iLEQ,typind,0) /* to Ȃeqߐ */
                     : gencompare(iGEQ,typind,0);/* downtoȂgeqߐ */ 
      }
      else pcerr(145,"Il") ;          /* ϐƏIľ^sK  */

     *forendlabel = crelabel() ;        /* forI̔ѐ惉x*/
     genjump(iFJP,*forendlabel);        /* fjpߐ                */

     if(debug) {                        /* debug̎                  */
      gattr = fattr   ;
      load()          ;                 /* ϐload             */
      checkbounds(fattr.typtr,52);      /* ͈̓`FbN               */
      store(fattr) ;
      gen2t(iLOD,lspfin,0,tempadr)  ;   /* ꎞϐ(2)load        */
      checkbounds(fattr.typtr,53)   ;   /* ͈̓`FbN               */
      gen2t(iSTR,lspfin,0,tempadr) ;    /* ꎞϐɎ̒lstr    */
      
      putlabel(*flooplabel) ;           /* [vxo           */
      gattr = fattr   ;
      load()          ;                 /* ϐload             */
      gen2t(iLOD,lspfin,0,tempadr)  ;   /* ꎞϐ(2)load        */
      (fsy == tosy) ? gencompare(iLEQ,typind,0) /* to Ȃleqߐ */
                    : gencompare(iGEQ,typind,0);/* downtoȂgeqߐ */ 
      genjump(iFJP,*forendlabel);       /* fjpߐ                */
     }
}

/**********************************************/
/* fordostatement() : fordoɑ̏ */
/*                     for   do          */
/**********************************************/
static void fordostatement(Set fsys,attr fattr,
                           enum symbol fsy,int looplabel)
{
     statement(fsys) ;                  /* ̏                   */

     gattr = fattr  ;
     load()          ;                  /* ϐload             */
     (fsy == tosy) ? gen1t(iINC,gattr.typtr,1)    /* doȂ    inc 1  */
                   : gen1t(iDEC,gattr.typtr,1) ;  /* downtoȂdec 1  */
     store(fattr) ;
     genjump(iUJP,looplabel) ;          /* ujp߂Ŗ߂              */
}

/*****************************************/
/* withstatement() : with̃RpC  */
/*****************************************/
static void withstatement(Set fsys)
{
  ctp *lcp     ;
  int oldlc    ;                         /* lc̑ޔ                */
  int oldtop   ;                         /* display top ̑ޔ      */
  boolean test ;
  Set ws       ;

     oldtop = top ;                     /* displaytopޔ     */
     oldlc  = lc  ;                     /* lcޔ               */

     do {
      if(sy == ident) {
       mkset(&ws,vars,field,-1) ;
       lcp = searchid(ws) ;             /* OϐtB[hT*/
       insymbol() ;
      }
      else {
       pcerr(2,"") ;                    /* OȂ                 */
       lcp = uvarptr ;                  /* `p̕ϐ|C^     */
      }
      mkset(&ws,comma,dosy,-1) ;
      orset(&ws,&fsys) ;
      selector(ws,lcp) ;                /* ϐ̏                 */
      if(gattr.typtr)
       if(gattr.typtr->form == records) 
        if(top < Displimit) {           /* display܂鎞        */
         top++ ;
         display[top].fname  = gattr.typtr->sf.re.fstfld ; /* ŏ̗*/
         display[top].flabel = nil ;    /* x̏ݒ         */
         if(gattr.access == drct) {     /* ڎQƂ̎               */
          display[top].occur = crec ;   /* Œ蕔̃R[h         */
          display[top].clev  = gattr.vlevel ; /* `             */
          display[top].cdspl = gattr.dplmt  ; /* ΃AhX         */
         }
         else {                         /* ԐڎQƂ̎               */
          loadaddress() ;               /* loadaddress            */
          updatelc(align(nilptr,lc)-lc);/* lc̋E               */
          gen2t(iSTR,nilptr,0,lc) ;     /* str                    */
          display[top].occur = vrec ;   /* σR[h             */
          display[top].vdspl = lc   ;   /* loadaddress i[ꏊ       */
          updatelc(ptrsize)         ;   /* lc1AhXi߂      */
          if(lc > lcmax) lcmax = lc ;
         }
        }
        else
         pcerr(603,inttoch((long)Displimit));/* O̓q[ */
       else pcerr(140,"")  ;            /* ϐ̌^R[hłȂ   */
      if(test = (sy == comma)) insymbol() ; /* , Ȃ玟̕ϐǂ   */
     } while(test) ;                    /* , Ȃ玟̕ϐ̏ց@   */

     if(sy == dosy) insymbol() ;
     else pcerr(54,"") ;                /* do Ȃ                  */

     statement(fsys)   ;                /* withz̏̕       */

     top = oldtop ;                     /* ɖ߂             */
     lc  = oldlc  ;                     /* lcɖ߂               */
}

/**************************************/
/* assignment() : ̃RpC  */
/**************************************/
static void assignment(Set fsys,ctp *fcp)
{
  attr lattr ;                          /* 1Ȏ                */
  Set ws ;

     ws = fsys ;
     addset(ws,becomes)    ;
     selector(ws, fcp)     ;            /* ӂ̏                 */

     if(fcp->klass == func)             /* ӂ֐̎             */
      if(fcp->n.pf.pfdeckind == standard) {
       pcerr(150,fcp->name) ;           /* W֐ւ̑͑ʖ     */
       gattr.typtr = nil ;
      }
      else if(fcp->n.pf.sd.d.pfkind == formal)
        pcerr(151,"") ;                 /* ֐ւ̑͑ʖ     */
      else if(display[fcp->n.pf.sd.d.pflev+1].funcname != fcp)      
       pcerr(177,fcp->name) ;           /* ł͑łȂ       */
      else display[fcp->n.pf.sd.d.pflev+1].funcassign = true ;
                                        /* ֐ւ̑         */

     if(sy == becomes) {
      if(gattr.typtr) 
       if((gattr.access != drct) ||     /* ڎQƂłȂ            */
          (gattr.typtr->form > power))  /* z^R[h^t@C^*/
        loadaddress() ;                 /* ̎́AAhX̂   */
      lattr = gattr   ;                 /* ̑ޔĂ     */
      insymbol() ;
      expression(fsys) ;                /* Eӂ̏                 */
      if(gattr.typtr)
       if(gattr.typtr->form <= power)   /* XJ[͈ͤ|C^W*/
        load() ;
       else loadaddress() ;

      if((lattr.typtr) && (gattr.typtr)) {
       if((lattr.typtr == realptr) &&          /* ӂ^        */
          (compatible(gattr.typtr,intptr))) {  /* Eӂ^̎      */
        gen0(iFLT) ;                           /* ɕϊ flt    */
        gattr.typtr = realptr ;
       }

       if(assigncompati(lattr.typtr,gattr.typtr)) /* \Ȏ     */
        switch(lattr.typtr->form) {           /* ^ɂĐU蕪 */
         case scalar   :
         case subrange :
           checkbounds(lattr.typtr,49) ;       /* ̃`FbN */ 
           store(lattr) ;
           break ;
         case pointer  :
           store(lattr) ;
           break ;
         case power :
           checkbounds(lattr.typtr,50) ;       /* ̃`FbN */
           store(lattr) ;
           break ;
         case arrays  :
         case records :
           gen2t(iMOV,nil,1,lattr.typtr->size) ;
        }
       else pcerr(129,"") ;             /* \łȂ@           */
      }
     }
     else pcerr(51,"") ;                /*  := Ȃ                 */
}

/*****************************************/
/* casestatement() : casẽRpC  */
/*****************************************/
typedef struct caseinfo cip ;
struct caseinfo {
   cip  *next   ;
   int  csstart ;                       /* P-codexl             */ 
   long cslab   ;                       /* 萔l                     */
} ;

static void casestatement(Set fsys)
{
  stp *lsp,*lsp1 ;
  cip *lpt,*lpt1,*lpt2,*lpt3,*fstptr;
  int laddr ;
  int lcix,lcix1;
  long lmin,lmax;
  union valu lval ;
  boolean test ;
  Set ws ;

     mkset(&ws,ofsy,comma,colon,-1) ;
     expression(ws) ;                   /* caseɑ̏         */
     load() ;                           /* ̒lload               */
     lsp = gattr.typtr ;
     if(lsp)
      if((lsp->form != scalar) || (lsp == realptr)) {
       pcerr(144,"casȇI") ;    /* łȂ               */
       lsp = nil     ;
      }
      else
       convertint(gattr.typtr) ;        /* KvȂordߐ        */

     lcix = crelabel() ;
     genjump(iUJP,lcix) ;               /* ̒l`FbN֔       */

     if(sy == ofsy) insymbol() ;
     else pcerr(8,"")          ;        /* of Ȃ                  */

     fstptr = nil ;
     laddr = crelabel() ;
     do {
      lpt = nil ;
      lcix1 = crelabel() ;
      mkset(&ws,endsy,semicolon,-1);
      if(! inset(ws,sy)) {              /* ; end łȂ           */
       do {
        mkset(&ws,comma,colon,-1);
        orset(&ws,&fsys) ;
        constant(ws,&lsp1,&lval) ;      /* 萔̏                 */
        if(lsp1)
         if(lsp == lsp1) {              /* ̌^ƒ萔̌^r     */
          lpt1 = fstptr ;
          lpt2 = nil    ;
          while(lpt1) {
           if(lpt1->cslab <= lval.ival) {
            if(lpt1->cslab == lval.ival)/* O̒萔Ɠl̎        */
             pcerr(156,"") ;            /* case̖Dēx`ꂽ*/
            break ;
           }
           lpt2 = lpt1;
           lpt1 = lpt1->next ;
          }
          lpt = (cip*)Malloc(sizeof(cip)) ;
          lpt->next = lpt1;
          lpt->cslab = lval.ival ;
          lpt->csstart = lcix1;
          if(!lpt2) fstptr = lpt;
          else lpt2->next = lpt;
         }
         else pcerr(147,"") ;           /* case̖Ď^ */
        if(test=(sy==comma)) insymbol() ; /* , ȂΎ̒萔ǂ   */
       } while(test) ;                  /*   , ȂΎ̒萔̏   */
       if(sy == colon) insymbol() ;
       else pcerr(5,"") ;               /* : Ȃ                   */
       putlabel(lcix1) ;
       ws = fsys;
       addset(ws,semicolon) ;
       lpt3 = lpt;                      /* QuickC̃oÔ(lptj)*/
       do {                             /* 񕜂̂ߌJԂ     */
        statement(ws)       ;           /* 萔ɑ΂镶̏       */
       } while(inset(statbegsys,sy));
       if(lpt3) genjump(iUJP,laddr);
      }
      if(test=(sy==semicolon)) insymbol() ;/* ; ȂΎ̒萔ǂ  */
     } while(test) ;                    /*    ; ȂΎ̒萔̏  */

     putlabel(lcix) ;

     if(fstptr) {                       /* reverse pointer            */
      lmax = fstptr->cslab ;
      lpt1 = fstptr ;
      fstptr = nil  ;
      do {
       lpt2 = lpt1->next ;
       lpt1->next = fstptr;
       fstptr = lpt1;
       lpt1 = lpt2 ;
      } while(lpt1) ;
      lmin = fstptr->cslab;
      if(lmax - lmin < Cixmax) {
       genchk(intptr,51,lmin,lmax);
       genldc('i',lmin);
       gen0(iSBI) ;
       lcix = crelabel() ;
       genjump(iXJP,lcix) ;
       putlabel(lcix);
       do {
        while(fstptr->cslab > lmin) {
         gen0(iUJC) ;
         lmin++ ;
        }
        genjump(iUJP,fstptr->csstart);
        fstptr = fstptr->next ;
        lmin++ ;
       } while(fstptr) ;
       putlabel(laddr) ;
      }
      else
       pcerr(601,inttoch((long)Cixmax)) ; /* casȇI͈̔͂傫*/
     }

     if(sy == endsy) insymbol() ;
     else pcerr(13,"") ;                /* end Ȃ                 */
}
